clear;
restoredefaultpath();
addpath("../SPIDER_functions/");

load("3Ddata1e6.mat");
U = data(:,:,:,:,1);
V = data(:,:,:,:,2);
W = data(:,:,:,:,3);
P = data(:,:,:,:,4);
T = data(:,:,:,:,5);

number_of_library_terms = 3;   %under-estimate this
number_of_windows       = 256; %number of domains we integrate over - 3D - START SMALL?
degrees_of_freedom      = 1;   %vectors have one degree of freedom DOES THIS NEED TO BE ALTERED?
dimension               = 4;   %how many dimensions does our data have? TED FOR 3D
envelope_power          = 4;   %weight is (1-x^2)^power

%%% WHY DOES THIS HAVE 4 DIMENSIONS FOR 2D? LEAVE WITH FOUR DIMENSIONS FOR 3D AS PER OTHER EXAMPLES
size_vec                = [32,32,32,32]; %how many gridpoints should we use per integration?

buffer                  = 0; %Do not use points this close to boundary

%define shorthand notation
nl = number_of_library_terms;
nw = number_of_windows;
dof= degrees_of_freedom;

%Make important objects for integration
pol      = envelope_pol( envelope_power, dimension );
G        = zeros( dof*nw, nl );
labels   = cell(nl, 1);
scales   = zeros(1,nl);

%we also need pol to be odd in time. multiply it by t
pol0 = pol; %save for normalization

size_of_data = size(U, 1:dimension);

seed = 1;
corners = pick_subdomains_manual_seed( size_of_data, size_vec, buffer, nw, seed );

grid = {x,y,z,t};

%Nondimensionalize and compute mean and variation of data
%TODO;

%%%%%%%%%%%%%%%%%%%%%%
% LIBRARY INTEGRATION
%%%%%%%%%%%%%%%%%%%%%%
a = 1;

labels{a} = "\nabla_i U";
G(:,a)    = SPIDER_integrate( U, [1], grid, corners, size_vec, pol ) + ...
            SPIDER_integrate( V, [2], grid, corners, size_vec, pol ) + ...
            SPIDER_integrate( W, [3], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} = "\nabla_i T";
G(:,a)    = SPIDER_integrate( T, [1], grid, corners, size_vec, pol ) + ...
            SPIDER_integrate( T, [2], grid, corners, size_vec, pol ) + ...
            SPIDER_integrate( T, [3], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} = "\partial_t P";
G(:,a)    = SPIDER_integrate( P, [4], grid, corners, size_vec, pol );     
scales(a) = 1; 
a = a+1;

%% normalize with non-odd polynomial.
norm_vec = SPIDER_integrate( 0*U + 1, [], grid, corners, size_vec, pol );      
norm_vec = repmat( norm_vec, [dof,1] );

G = G./norm_vec;
G = G./scales;

function d=SPIDER_integrate_vector( U,V,W, deriv, grid, corners, size_vec, pol )
   a = SPIDER_integrate( U, deriv, grid, corners, size_vec, pol );
   b = SPIDER_integrate( V, deriv, grid, corners, size_vec, pol ); 
   c = SPIDER_integrate( W, deriv, grid, corners, size_vec, pol );
   d = [a;b;c];
end
