clear;
restoredefaultpath();
addpath("../SPIDER_functions/");

load("3Ddata1e6.mat");
U = data(:,:,:,:,1);
V = data(:,:,:,:,2);
W = data(:,:,:,:,3);
P = data(:,:,:,:,4);
T = data(:,:,:,:,5);

number_of_library_terms = 3;   %under-estimate this
number_of_windows       = 256; %number of domains we integrate over - 3D - START SMALL?
degrees_of_freedom      = 1;   %vectors have one degree of freedom DOES THIS NEED TO BE ALTERED?
dimension               = 4;   %how many dimensions does our data have? UPDATED FOR 3D
envelope_power          = 8;   %weight is (1-x^2)^power

%%% WHY DOES THIS HAVE 4 DIMENSIONS FOR 2D? LEAVE WITH FOUR DIMENSIONS FOR 3D AS PER OTHER EXAMPLES
size_vec                = [32,32,32,32]; %how many gridpoints should we use per integration?

buffer                  = 0; %Do not use points this close to boundary

%define shorthand notation
nl = number_of_library_terms;
nw = number_of_windows;
dof= degrees_of_freedom;

%Make important objects for integration
pol      = envelope_pol( envelope_power, dimension );
G        = zeros( dof*nw, nl );
labels   = cell(nl, 1);
scales   = zeros(1,nl);

%we also need pol to be odd in time. multiply it by t
pol0 = pol; %save for normalization

size_of_data = size(U, 1:dimension);

seed = 1;
corners = pick_subdomains_manual_seed( size_of_data, size_vec, buffer, nw, seed );

grid = {x,y,z,t};

%Nondimensionalize and compute mean and variation of data
%TODO;

%%%%%%%%%%%%%%%%%%%%%%
% LIBRARY INTEGRATION
%%%%%%%%%%%%%%%%%%%%%%
a = 1;

labels{a} =  "W_t";
G(:,a)    = SPIDER_integrate( W, [4], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "U.W_x";
G(:,a)    = SPIDER_integrate( U.*W, [1], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "V.W_y";
G(:,a)    = SPIDER_integrate( V.*W, [2], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "W.W_z";
G(:,a)    = SPIDER_integrate( W.*W, [3], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "P_x";
G(:,a)    = SPIDER_integrate( P, [1], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "P_y";
G(:,a)    = SPIDER_integrate( P, [2], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "P_z";
G(:,a)    = SPIDER_integrate( P, [3], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "W_xx";
G(:,a)    = SPIDER_integrate( W, [1,1], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "W_yy";
G(:,a)    = SPIDER_integrate( W, [2,2], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "W_zz";
G(:,a)    = SPIDER_integrate( W, [3,3], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "T";
G(:,a)    = SPIDER_integrate( T, [], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "T_x";
G(:,a)    = SPIDER_integrate( T, [1], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "T_y";
G(:,a)    = SPIDER_integrate( T, [2], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "T_z";
G(:,a)    = SPIDER_integrate( T, [3], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

%normalize with non-odd polynomial.
norm_vec = SPIDER_integrate( 0*U + 1, [], grid, corners, size_vec, pol );      
%norm_vec = repmat( norm_vec, [dof*numel(u0s),1] );

G = G./norm_vec;
G = G./scales;

