clear;
restoredefaultpath();
addpath("../SPIDER_functions/");


load("turbprofiledata1e12Fourier.mat");
U = data(:,:,1);
W = data(:,:,2);
T = data(:,:,3);
R = data(:,:,4);
R11 = data(:,:,5);
R12 = data(:,:,6);
R22 = data(:,:,7);
Fx = data(:,:,8);
Fz = data(:,:,9);
Q = data(:,:,10);
Rpt5 = data(:,:,11);
R1pt5 = data(:,:,12);

number_of_library_terms = 3;   %under-estimate this
number_of_windows       = 2048; %number of domains we integrate over 
degrees_of_freedom      = 1;   %vectors have one degree of freedom
dimension               = 2;   %how many dimensions does our data have?
envelope_power          = 2;   %weight is (1-x^2)^power
size_vec                = [1023,100]; %how many gridpoints should we use per integration?
buffer                  = 0; %Do not use points this close to boundary

%define shorthand notation
nl = number_of_library_terms;
nw = number_of_windows;
dof= degrees_of_freedom;

%Make important objects for integration
pol      = envelope_pol( envelope_power, dimension );
G        = zeros( dof*nw, nl );
labels   = cell(nl, 1);
scales   = zeros(1,nl);

%we also need pol to be odd in time. multiply it by t
pol0 = pol; %save for normalization

size_of_data = size(U, 1:dimension);

seed = 1;
corners = pick_subdomains_manual_seed( size_of_data, size_vec, buffer, nw, seed );

grid = {z,t};

%Nondimensionalize and compute mean and variation of data
%TODO;

%%%%%%%%%%%%%%%%%%%%%%
% LIBRARY INTEGRATION
%%%%%%%%%%%%%%%%%%%%%%
a = 1;

labels{a} =  "dRdt + W.R_z + 2.R12.U_z + 2.R22.W_z - 2.Fz - 1e-6.R_zz";
G(:,a)    = SPIDER_integrate( R, [2], grid, corners, size_vec, pol ) + ...
            SPIDER_integrate( W.*R, [1], grid, corners, size_vec, pol ) + ...
            2*SPIDER_integrate( R12.*U, [1], grid, corners, size_vec, pol ) + ...
            2*SPIDER_integrate( R22.*W, [1], grid, corners, size_vec, pol ) + ...
            -2*SPIDER_integrate( Fz, [], grid, corners, size_vec, pol ) + ...
            -1e-6*SPIDER_integrate( R, [1,1], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "R1pt5";
G(:,a)    = SPIDER_integrate( R1pt5, [], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

labels{a} =  "R";
G(:,a)    = SPIDER_integrate( R, [], grid, corners, size_vec, pol );
scales(a) = 1;
a = a+1;

%normalize with non-odd polynomial.
norm_vec = SPIDER_integrate( 0*U + 1, [], grid, corners, size_vec, pol );      
%norm_vec = repmat( norm_vec, [dof*numel(u0s),1] );

G = G./norm_vec;
G = G./scales;  
